/*
 * @(#)58    1.1  src/pdwebrte/azn/eaidemo/EAIDemo/JavaSource/com/tivoli/am/eb/web/localresponsedemo/TAMOperationHandler.java, pdweb.ws.authn.eai, amwebrte700  8/20/04  16:50:12
 * ===========================================================================
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2004 All Rights Reserved.
 * ===========================================================================
 *
 */
package com.tivoli.am.eb.web.localresponsedemo;


import java.io.IOException;
import java.io.PrintWriter;

import java.net.URLEncoder;

import java.util.Enumeration;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * Responds appropriately to a local response redirect sent from WebSEAL.
 *
 * @author Tivoli Systems
 */
public class TAMOperationHandler extends HttpServlet implements Servlet {

    public void doGet(HttpServletRequest req, HttpServletResponse resp)
               throws ServletException, IOException
    {
        // get the operation out of the request parameters
        String operation = req.getParameter(LocalResponseRedirectConstants.TAM_OPERATION);

        // figure out what to do with the request
        if(operation.equalsIgnoreCase(LocalResponseRedirectConstants.RESPONSE_OP_LOGIN)) {
            resp.sendRedirect(resp.encodeRedirectURL(constructURL("./eailogin.jsp",
                                                                  req)));
        } else if(operation.equalsIgnoreCase(LocalResponseRedirectConstants.RESPONSE_OP_STEPUP_LOGIN_ERROR)) {
            resp.sendRedirect(resp.encodeRedirectURL(constructURL("./eailogin.jsp",
                                                                  req)));
        } else if(operation.equalsIgnoreCase(LocalResponseRedirectConstants.RESPONSE_OP_LOGOUT)) {
            performLogout(resp);
        } else {
            resp.sendRedirect(resp.encodeRedirectURL(constructURL("./error.jsp",
                                                                  req)));
        }
    }


    /**
     * Construct a url for redirection to a response page. Passes all of the
     * parameters passed to this servlet.
     *
     * @param location the location of the page to redirect to
     * @param req the http request passed to this servlet
     *
     * @return a string for redirection including all parameters passed in the
     *         request to this servlet.
     */
    private String constructURL(String location, HttpServletRequest req) {
        // add the location and the query character
        String url = location.trim() + "?";

        // tack on the macro values in name=value& format
        Enumeration parameters = req.getParameterNames();
        String name = null;
        String value = null;

        while(parameters.hasMoreElements()) {
            name = (String)parameters.nextElement();
            value = req.getParameter(name);            
            url = url + name + "=" + URLEncoder.encode(value) + "&";
        }

        // there will be a trailing & -- get rid of it
        return url.substring(0, (url.length() - 1));
    }


    /**
     * Display a logout page for users who have logged out.
     *
     * @param resp the http response being sent to the client.
     *
     * @throws ServletException if there's an error encountered in writing the
     *         response.
     */
    private void performLogout(HttpServletResponse resp)
                        throws ServletException
    {
        resp.setContentType("text/html");

        PrintWriter out = null;

        try {
            out = resp.getWriter();
        } catch(IOException e) {
            throw new ServletException(e);
        }

        out.println("<HTML>");
        out.println("<HEAD><TITLE>Logout</TITLE></HEAD>");
        out.println("<BODY><H1>Logout</H1><P>You have been logged out.</P></BODY>");
        out.println("</HMTL>");

        resp.setStatus(200);
    }
}
